# TODO
# - x32 not supported by upstream: http://www.freelists.org/post/luajit/Building-luajit202-on-x32,1
#
# Conditional build:
%bcond_without	lua51		# LuaJIT without Lua 5.2 extensions
%bcond_without	lua52		# LuaJIT with Lua 5.2 extensions

%define		snap		20240704
%define		rel		6
# git show -s --format=%ct
%define		rolling_ver	1720049189
Summary:	Just-in-Time compiler for Lua
Summary(pl.UTF-8):	Kompilator JIT dla języka Lua
Name:		luajit
Version:	2.1.0
Release:	0.%{snap}.%{rel}
License:	MIT
Group:		Libraries
# Source0Download: http://luajit.org/download.html
Source0:	%{name}-%{version}-%{snap}.tar.xz
# Source0-md5:	8a1c8fe490bf2619948dcc5790c06361
Patch0:		config.patch
Patch1:		abi-5.2.patch
URL:		http://luajit.org/
BuildRequires:	sed >= 4.0
BuildRequires:	tar >= 1:1.22
BuildRequires:	xz
Requires:	%{name}-libs = %{version}-%{release}
ExclusiveArch:	%{ix86} %{x8664} %{arm} aarch64 mips mips64 mipsel ppc
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		luajit_abi	2.1

%description
LuaJIT is a Just-In-Time (JIT) compiler for the Lua programming
language.

%description -l pl.UTF-8
LuaJIT to działający w locie (Just-In-Time) kompilator języka Lua.

%package common
Summary:	Common files for LuaJIT libraries
Summary(pl.UTF-8):	Pliki wspólne dla bibliotek LuaJIT
Group:		Libraries
Conflicts:	luajit-libs < 2.1.0-0.20240704.5

%description common
Common files for LuaJIT libraries.

%description common -l pl.UTF-8
Pliki wspólne dla bibliotek LuaJIT.

%package libs
Summary:	LuaJIT libraries
Summary(pl.UTF-8):	Biblioteki LuaJIT
Group:		Libraries
Requires:	%{name}-common = %{version}-%{release}

%description libs
LuaJIT libraries.

%description libs -l pl.UTF-8
Biblioteki LuaJIT.

%package common-devel
Summary:	Common header files for LuaJIT library
Summary(pl.UTF-8):	Wspólne pliki nagłówkowe biblioteki LuaJIT
Group:		Development/Libraries
Conflicts:	luajit-devel < 2.1.0-0.20240704.5

%description common-devel
Common header files for LuaJIT library.

%description common-devel -l pl.UTF-8
Wspólne pliki nagłówkowe biblioteki LuaJIT.

%package devel
Summary:	Header files for LuaJIT library
Summary(pl.UTF-8):	Pliki nagłówkowe biblioteki LuaJIT
Group:		Development/Libraries
Requires:	%{name}-common-devel = %{version}-%{release}
Requires:	%{name}-libs = %{version}-%{release}

%description devel
Header files for LuaJIT library.

%description devel -l pl.UTF-8
Pliki nagłówkowe biblioteki LuaJIT.

%package static
Summary:	Static LuaJIT library
Summary(pl.UTF-8):	Statyczna biblioteka LuaJIT
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}

%description static
Static LuaJIT library.

%description static -l pl.UTF-8
Statyczna biblioteka LuaJIT.

%package -n luajit52
Summary:	Just-in-Time compiler for Lua (with Lua 5.2 extensions)
Summary(pl.UTF-8):	Kompilator JIT dla języka Lua (z rozszerzeniami Lua 5.2)
Group:		Libraries
Requires:	luajit52-libs = %{version}-%{release}

%description -n luajit52
LuaJIT is a Just-In-Time (JIT) compiler for the Lua programming
language (with Lua 5.2 extensions).

%description -n luajit52 -l pl.UTF-8
LuaJIT to działający w locie (Just-In-Time) kompilator języka Lua (z
rozszerzeniami Lua 5.2).

%package -n luajit52-libs
Summary:	LuaJIT libraries (with Lua 5.2 extensions)
Summary(pl.UTF-8):	Biblioteki LuaJIT (z rozszerzeniami Lua 5.2)
Group:		Libraries
Requires:	%{name}-common = %{version}-%{release}

%description -n luajit52-libs
LuaJIT libraries (with Lua 5.2 extensions).

%description -n luajit52-libs -l pl.UTF-8
Biblioteki LuaJIT (z rozszerzeniami Lua 5.2).

%package -n luajit52-devel
Summary:	Header files for LuaJIT library (with Lua 5.2 extensions)
Summary(pl.UTF-8):	Pliki nagłówkowe biblioteki LuaJIT (z rozszerzeniami Lua 5.2)
Group:		Development/Libraries
Requires:	%{name}-common-devel = %{version}-%{release}
Requires:	luajit52-libs = %{version}-%{release}

%description -n luajit52-devel
Header files for LuaJIT library (with Lua 5.2 extensions).

%description -n luajit52-devel -l pl.UTF-8
Pliki nagłówkowe biblioteki LuaJIT (z rozszerzeniami Lua 5.2).

%package -n luajit52-static
Summary:	Static LuaJIT library (with Lua 5.2 extensions)
Summary(pl.UTF-8):	Statyczna biblioteka LuaJIT (z rozszerzeniami Lua 5.2)
Group:		Development/Libraries
Requires:	luajit52-devel = %{version}-%{release}

%description -n luajit52-static
Static LuaJIT library (with Lua 5.2 extensions).

%description -n luajit52-static -l pl.UTF-8
Statyczna biblioteka LuaJIT (z rozszerzeniami Lua 5.2).

%prep
%setup -qcT
%if %{with lua51}
tar --one-top-level=luajit-51 --strip-components=1 -xf %{SOURCE0}
cd luajit-51
%patch -P 0 -p1

# preserve timestamps
sed -i -e '/install -m/s/-m/-p -m/' Makefile

echo %{rolling_ver} > .relver
cd ..
%endif
%if %{with lua52}
tar --one-top-level=luajit-52 --strip-components=1 -xf %{SOURCE0}
cd luajit-52
%patch -P 0 -p1
%patch -P 1 -p1

# preserve timestamps
sed -i -e '/install -m/s/-m/-p -m/' Makefile

echo %{rolling_ver} > .relver
cd ..
%endif

%build
# Q= - enable verbose output
# E= @: - disable @echo messages
# NOTE: we use amalgamated build as per documentation suggestion doc/install.html
for v in %{?with_lua51:51} %{?with_lua52:52}; do
%{__make} -C luajit-$v \
	VERSION="%{version}" \
	PREFIX=%{_prefix} \
	MULTILIB=%{_lib} \
	LMULTILIB=%{_lib} \
	CC="%{__cc}" \
	CCOPT="%{rpmcflags} -fomit-frame-pointer" \
	CCOPT_x86= \
	LDFLAGS="%{rpmldflags}" \
	TARGET_STRIP=: \
	E="@:" \
	Q= \
	amalg
done

%install
rm -rf $RPM_BUILD_ROOT

install -d $RPM_BUILD_ROOT%{_libdir}/luajit/%{luajit_abi}

%if %{with lua52}
%{__make} -C luajit-52 install \
	DESTDIR=$RPM_BUILD_ROOT \
	VERSION="%{version}" \
	PREFIX=%{_prefix} \
	MULTILIB=%{_lib} \
	LMULTILIB=%{_lib} \
	INSTALL_BIN=$RPM_BUILD_ROOT%{_bindir} \
	INSTALL_LIB=$RPM_BUILD_ROOT%{_libdir} \
	INSTALL_SHARE=$RPM_BUILD_ROOT%{_datadir} \
	INSTALL_MAN=$RPM_BUILD_ROOT%{_mandir}/man1 \
	INSTALL_PKGCONFIG=$RPM_BUILD_ROOT%{_pkgconfigdir} \
	LDCONFIG="/sbin/ldconfig -n"
%{__mv} $RPM_BUILD_ROOT%{_bindir}/luajit{,52}-%{version}
%{__rm} $RPM_BUILD_ROOT%{_bindir}/luajit
%{__ln_s} luajit52-%{version} $RPM_BUILD_ROOT%{_bindir}/luajit52
%{__mv} $RPM_BUILD_ROOT%{_pkgconfigdir}/luajit{,52}.pc
%{__mv} $RPM_BUILD_ROOT%{_mandir}/man1/luajit{,52}.1
%endif

%if %{with lua51}
%{__make} -C luajit-51 install \
	DESTDIR=$RPM_BUILD_ROOT \
	VERSION="%{version}" \
	PREFIX=%{_prefix} \
	MULTILIB=%{_lib} \
	LMULTILIB=%{_lib} \
	INSTALL_BIN=$RPM_BUILD_ROOT%{_bindir} \
	INSTALL_LIB=$RPM_BUILD_ROOT%{_libdir} \
	INSTALL_SHARE=$RPM_BUILD_ROOT%{_datadir} \
	INSTALL_MAN=$RPM_BUILD_ROOT%{_mandir}/man1 \
	INSTALL_PKGCONFIG=$RPM_BUILD_ROOT%{_pkgconfigdir} \
	LDCONFIG="/sbin/ldconfig -n"
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post	libs -p /sbin/ldconfig
%postun	libs -p /sbin/ldconfig

%post	-n luajit52-libs -p /sbin/ldconfig
%postun	-n luajit52-libs -p /sbin/ldconfig

%if %{with lua51}
%files
%defattr(644,root,root,755)
%doc luajit-51/{COPYRIGHT,README}
%attr(755,root,root) %{_bindir}/luajit
%attr(755,root,root) %{_bindir}/luajit-%{version}
%{_mandir}/man1/luajit.1*
%endif

%files common
%defattr(644,root,root,755)
%dir %{_libdir}/luajit
%dir %{_libdir}/luajit/%{luajit_abi}
%dir %{_datadir}/luajit
%{_datadir}/luajit/%{luajit_abi}
%dir %{_libdir}/lua

%if %{with lua51}
%files libs
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libluajit-5.1.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libluajit-5.1.so.2
# lua module dirs (shared with lua interpreters)
%dir %{_libdir}/lua/5.1
%dir %{_datadir}/lua/5.1
%endif

%files common-devel
%defattr(644,root,root,755)
%doc luajit-%{?with_lua51:51}%{!?with_lua51:52}/doc/*
%{_includedir}/luajit-%{luajit_abi}

%if %{with lua51}
%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libluajit-5.1.so
%{_pkgconfigdir}/luajit.pc

%files static
%defattr(644,root,root,755)
%{_libdir}/libluajit-5.1.a
%endif

%if %{with lua52}
%files -n luajit52
%defattr(644,root,root,755)
%doc luajit-52/{COPYRIGHT,README}
%attr(755,root,root) %{_bindir}/luajit52
%attr(755,root,root) %{_bindir}/luajit52-%{version}
%{_mandir}/man1/luajit52.1*

%files -n luajit52-libs
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libluajit-5.2.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libluajit-5.2.so.2
# lua module dirs (shared with lua interpreters)
%dir %{_libdir}/lua/5.2
%dir %{_datadir}/lua/5.2

%files -n luajit52-devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libluajit-5.2.so
%{_pkgconfigdir}/luajit52.pc

%files -n luajit52-static
%defattr(644,root,root,755)
%{_libdir}/libluajit-5.2.a
%endif
%changelog
* Sat Dec 28 2024 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/luajit.git;a=log;h=master

* Sat Dec 28 2024 Jan Palus <atler@pld-linux.org> 1797dac
- add C: to common subpackages; rel 6

* Thu Dec 26 2024 Jan Palus <atler@pld-linux.org> 1b42c8c
- relup.sh friendly release; rel 5

* Thu Dec 26 2024 Jan Palus <atler@pld-linux.org> 509ad26
- add bconds for building with/without lua 5.2 exts

* Thu Dec 26 2024 Jan Palus <atler@pld-linux.org> 98da746
- build luajit both with and wthout lua 5.2 compat changes

* Sun Dec 22 2024 Jan Palus <atler@pld-linux.org> 69643b4
- rel 4

* Sun Dec 22 2024 Jan Palus <atler@pld-linux.org> 9cb92fa
- more vars changed to correct soname

* Sun Dec 22 2024 Jan Rękorajski <baggins@pld-linux.org> a7e4fc7
- really enable lua 5.2 abi, rel 3

* Sun Dec 22 2024 Jan Rękorajski <baggins@pld-linux.org> c792452
- build with lua 5.2 abi, rel 2

* Tue Jul 09 2024 Jan Palus <atler@pld-linux.org> d5a2334
- up to 20240704 snap

* Wed Oct 11 2023 Jan Palus <atler@pld-linux.org> c7f67ef
- up to 20231008 snap

* Wed Jul 26 2023 Jan Palus <atler@pld-linux.org> adb2c62
- up to 20230712 snap

* Fri Dec 30 2022 Jan Palus <atler@pld-linux.org> 3d4534b
- up to 20221222 snap

* Tue May 03 2022 Jan Palus <atler@pld-linux.org> ba0dac0
- don't strip binaries

* Tue May 03 2022 Jan Palus <atler@pld-linux.org> adfec2e
- split off -libs subpackage

* Mon May 02 2022 Jan Palus <atler@pld-linux.org> 6b1e534
- adjust default lua search path

* Sat Apr 30 2022 Jan Palus <atler@pld-linux.org> e7941b7
- up to 2.1.0 snap

* Thu Mar 01 2018 Jakub Bogusz <qboosh@pld-linux.org> 071e6f8
- updated to 2.0.5

* Sun Jul 26 2015 Elan Ruusamäe <glen@delfi.ee> 7948665
- add x32 arch note

* Tue May 19 2015 Łukasz Kieś <kiesiu@pld-linux.org> f23c884
- updated to 2.0.4

* Thu Apr 23 2015 Jakub Bogusz <qboosh@pld-linux.org> b12acbc
- release 3

